diff --git a/test/unit/diagnosis_agent_test.rb b/test/unit/diagnosis_agent_test.rb
index 8815a36..677e00f 100644
--- a/test/unit/diagnosis_agent_test.rb
+++ b/test/unit/diagnosis_agent_test.rb
@@ -31,7 +31,7 @@ class DiagnosisAgentTest < Minitest::Test
     @tmp = Dir.mktmpdir("hive-diagnosis-agent")
     @project_root = File.join(@tmp, "project")
     @slug = "red-task-260516-aaaa"
-    @folder = File.join(@project_root, ".hive-state", "stages", "6-review", @slug)
+    @folder = File.join(@project_root, ".hive", "stages", "6-review", @slug)
     FileUtils.mkdir_p(@folder)
     @state_file = File.join(@folder, "task.md")
     File.write(@state_file, "<!-- REVIEW_ERROR phase=fix pass=1 -->\n")
@@ -267,9 +267,9 @@ class DiagnosisAgentTest < Minitest::Test
     # An unknown agent profile is rejected by AgentProfiles.lookup with
     # Hive::ConfigError → exit 78. DiagnosisAgent must propagate that
     # without writing a partial artifact.
-    FileUtils.mkdir_p(File.dirname(@state_file).then { |d| File.join(@project_root, ".hive-state") })
+    FileUtils.mkdir_p(File.dirname(@state_file).then { |d| File.join(@project_root, ".hive") })
     File.write(
-      File.join(@project_root, ".hive-state", "config.yml"),
+      File.join(@project_root, ".hive", "config.yml"),
       YAML.dump("execute" => { "agent" => "no-such-agent" })
     )
 
@@ -442,7 +442,7 @@ class DiagnosisAgentTest < Minitest::Test
     worktree_root = File.join(@tmp, "worktrees")
     FileUtils.mkdir_p(worktree_root)
     File.write(
-      File.join(@project_root, ".hive-state", "config.yml"),
+      File.join(@project_root, ".hive", "config.yml"),
       YAML.dump("worktree_root" => worktree_root)
     )
     @task.worktree_path = File.join(@tmp, "outside-worktree")
@@ -469,7 +469,7 @@ class DiagnosisAgentTest < Minitest::Test
       )
     )
     File.write(
-      File.join(@project_root, ".hive-state", "config.yml"),
+      File.join(@project_root, ".hive", "config.yml"),
       YAML.dump("execute" => { "agent" => "custom" })
     )
     spawned = false
diff --git a/test/unit/git_ops_test.rb b/test/unit/git_ops_test.rb
index 669a61c..21e6b9d 100644
--- a/test/unit/git_ops_test.rb
+++ b/test/unit/git_ops_test.rb
@@ -24,9 +24,10 @@ class GitOpsTest < Minitest::Test
       ops = Hive::GitOps.new(dir)
       assert_equal :created, ops.hive_state_init
       assert ops.hive_state_branch_exists?, "hive/state branch should exist"
-      assert File.directory?(File.join(dir, ".hive-state")), ".hive-state worktree should be created"
+      ops2 = Hive::GitOps.new(dir)
+      assert File.directory?(File.join(dir, ".hive")), ".hive worktree should be created (canonical scaffold root)"
       Hive::Stages::DIRS.each do |stage|
-        assert File.directory?(File.join(dir, ".hive-state", "stages", stage)),
+        assert File.directory?(File.join(dir, ".hive", "stages", stage)),
                "stage dir #{stage} should exist"
       end
       log = `git -C #{dir} log --format=%s hive/state`.strip
@@ -48,7 +49,8 @@ class GitOpsTest < Minitest::Test
       ops.hive_state_init
       assert_equal :added, ops.add_hive_state_to_master_gitignore!
       content = File.read(File.join(dir, ".gitignore"))
-      assert_includes content, "/.hive-state/"
+      assert_includes content, "/.hive/", "canonical pattern must be ignored"
+      refute_includes content, "/.hive-bogus/"
       assert_equal :already, ops.add_hive_state_to_master_gitignore!, "should be idempotent on re-run"
     end
   end
@@ -57,12 +59,12 @@ class GitOpsTest < Minitest::Test
     with_tmp_git_repo do |dir|
       ops = Hive::GitOps.new(dir)
       ops.hive_state_init
-      task_dir = File.join(dir, ".hive-state", "stages", "1-inbox", "foo-260424-aaaa")
+      task_dir = File.join(ops.hive_state_path, "stages", "1-inbox", "foo-260424-aaaa")
       FileUtils.mkdir_p(task_dir)
       File.write(File.join(task_dir, "idea.md"), "# Foo\n<!-- WAITING -->\n")
       result = ops.hive_commit(stage_name: "1-inbox", slug: "foo-260424-aaaa", action: "captured")
       assert_equal :committed, result
-      log = `git -C #{File.join(dir, ".hive-state")} log --format=%s -1`.strip
+      log = `git -C #{ops.hive_state_path} log --format=%s -1`.strip
       assert_equal "hive: 1-inbox/foo-260424-aaaa captured", log
     end
   end
@@ -81,7 +83,7 @@ class GitOpsTest < Minitest::Test
       ops = Hive::GitOps.new(dir)
       ops.hive_state_init
       ops.add_hive_state_to_master_gitignore!
-      File.write(File.join(dir, ".hive-state", "stages", "1-inbox", "x.md"), "x")
+      File.write(File.join(ops.hive_state_path, "stages", "1-inbox", "x.md"), "x")
       ops.hive_commit(stage_name: "1-inbox", slug: "x", action: "captured")
 
       master_log = `git -C #{dir} log --format=%s master`.strip.split("\n")
diff --git a/test/unit/paths_test.rb b/test/unit/paths_test.rb
new file mode 100644
index 0000000..0972fd1
--- /dev/null
+++ b/test/unit/paths_test.rb
@@ -0,0 +1,176 @@
+require "test_helper"
+require "hive/paths"
+require "hive/config"
+require "fileutils"
+
+# Unit tests for Hive::Paths (plan figure-out-way-to-install-260513-4a0a U1):
+# XDG resolution precedence, HIVE_HOME sandbox collapsing, runtime file
+# naming per mode, and the legacy ~/Dev/hive → ~/.config/hive one-time
+# config migration performed by Hive::Config.migrate_legacy_config!.
+class HivePathsTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    Hive::Config.reset_migration_memo!
+  end
+
+  def teardown
+    Hive::Config.reset_migration_memo!
+  end
+
+  def with_env(overrides)
+    saved = {}
+    overrides.each { |k, v| saved[k] = ENV[k]; ENV[k] = v }
+    yield
+  ensure
+    saved.each { |k, v| ENV[k] = v.nil? ? nil : v.to_s }
+  end
+
+  # ── Default (no sandbox): standard XDG layout ─────────────────────────
+
+  def test_config_dir_defaults_to_xdg_config_home
+    with_env("HIVE_HOME" => nil, "XDG_CONFIG_HOME" => "/tmp/cfg-home") do
+      assert_equal File.join("/tmp/cfg-home", "hive"), Hive::Paths.config_dir
+    end
+  end
+
+  def test_state_data_cache_dirs_default_to_xdg_homes
+    with_env(
+      "HIVE_HOME" => nil,
+      "XDG_STATE_HOME" => "/tmp/state-home",
+      "XDG_DATA_HOME" => "/tmp/data-home",
+      "XDG_CACHE_HOME" => "/tmp/cache-home"
+    ) do
+      assert_equal "/tmp/state-home/hive", Hive::Paths.state_dir
+      assert_equal "/tmp/data-home/hive", Hive::Paths.data_dir
+      assert_equal "/tmp/cache-home/hive", Hive::Paths.cache_dir
+    end
+  end
+
+  def test_empty_env_vars_fall_back_to_defaults_under_home
+    with_env("HIVE_HOME" => "", "XDG_CONFIG_HOME" => "") do
+      assert_equal File.expand_path("~/.config/hive"), Hive::Paths.config_dir
+    end
+  end
+
+  # ── HIVE_HOME sandbox: everything collapses inside the sandbox ────────
+
+  def test_sandbox_collapse_all_dirs_inside_hive_home
+    with_env("HIVE_HOME" => "/tmp/hive-sandbox") do
+      assert_predicate Hive::Paths, :sandboxed?
+      assert_equal "/tmp/hive-sandbox", Hive::Paths.config_dir
+      assert_equal "/tmp/hive-sandbox", Hive::Paths.state_dir
+      assert_equal "/tmp/hive-sandbox/share", Hive::Paths.data_dir
+      assert_equal "/tmp/hive-sandbox/cache", Hive::Paths.cache_dir
+      # Historical filenames preserved inside a sandbox so existing
+      # tooling (and the daemon tests that assert exact pid_file paths)
+      # keep working.
+      assert_equal "/tmp/hive-sandbox/.daemon.pid", Hive::Paths.daemon_pid_file
+      assert_equal "/tmp/hive-sandbox/logs/daemon.log", Hive::Paths.daemon_log_file
+      assert_equal "/tmp/hive-sandbox/.bot.pid", Hive::Paths.bot_pid_file
+      assert_equal "/tmp/hive-sandbox/logs/bot.log", Hive::Paths.bot_log_file
+      assert_equal "/tmp/hive-sandbox/.bot.last_seen_update_id",
+                   Hive::Paths.bot_last_seen_file
+    end
+  end
+
+  # ── Runtime files under the XDG layout ────────────────────────────────
+
+  def test_daemon_pid_log_live_in_state_dir_on_xdg_layout
+    with_env("HIVE_HOME" => nil, "XDG_STATE_HOME" => "/custom-state") do
+      # Plan U1 scenario (3): XDG_STATE_HOME=/custom → daemon PID/log land there.
+      assert_equal "/custom-state/hive/daemon.pid", Hive::Paths.daemon_pid_file
+      assert_equal "/custom-state/hive/logs/daemon.log", Hive::Paths.daemon_log_file
+      assert_equal "/custom-state/hive/bot.pid", Hive::Paths.bot_pid_file
+    end
+  end
+
+  def test_install_receipt_lives_in_config_dir
+    with_env("HIVE_HOME" => nil, "XDG_CONFIG_HOME" => "/tmp/cfg2") do
+      assert_equal "/tmp/cfg2/hive/install.yml", Hive::Paths.install_receipt_path
+    end
+  end
+
+  def test_legacy_hive_home_is_dev_hive
+    assert_equal File.expand_path("~/Dev/hive"), Hive::Paths.legacy_hive_home
+  end
+
+  # ── One-time legacy migration via Config.global_config_path ──────────
+
+  def test_migration_moves_legacy_config_with_notice_when_no_xdg_config
+    with_tmp_dir do |home|
+      FileUtils.mkdir_p(File.join(home, ".dev-hive"))
+      legacy_cfg = File.join(home, ".dev-hive", "config.yml")
+      File.write(legacy_cfg, { "registered_projects" => [ { "name" => "demo" } ] }.to_yaml)
+
+      with_env("HIVE_HOME" => nil,
+               "XDG_CONFIG_HOME" => File.join(home, ".config"),
+               # Point Paths.legacy_hive_home at our fixture tree without
+               # touching $HOME: stub via a subclass is cleaner than faking HOME.
+               ) do
+        stub_legacy_home(File.join(home, ".dev-hive")) do
+          out, err = capture_io do
+            path = Hive::Config.global_config_path
+            assert_equal File.join(home, ".config", "hive", "config.yml"), path
+          end
+          assert_match(/migrated global config/, err)
+          refute File.exist?(legacy_cfg), "migration must MOVE (not copy) the legacy file"
+          assert_equal({ "name" => "demo" },
+                       YAML.safe_load(File.read(Hive::Config.global_config_path))["registered_projects"].first)
+        end
+      end
+    end
+  end
+
+  def test_migration_never_runs_in_a_hive_home_sandbox
+    with_tmp_dir do |sandbox|
+      with_env("HIVE_HOME" => sandbox) do
+        err = capture_stderr do
+          Hive::Config.migrate_legacy_config!
+        end
+        assert_empty(err)
+      end
+    end
+  end
+
+  def test_write_global_config_creates_mode_600_file
+    with_env("HIVE_HOME" => nil, "XDG_CONFIG_HOME" => nil) do |saved|
+      home = Dir.mktmpdir
+      ENV["XDG_CONFIG_HOME"] = File.join(home, ".config")
+      stub_legacy_home(File.join(home, "nope")) do
+        begin
+          data = { "registered_projects" => [] }
+          Hive::Config.write_global_config!(data)
+          path = Hive::Config.global_config_path
+          assert File.exist?(path)
+          assert_equal 0o600, (File.stat(path).mode & 0o777)
+        ensure
+          FileUtils.rm_rf(home)
+        end
+      end
+    end
+  end
+
+  private
+
+  # Temporarily stub Paths.legacy_hive_home so migration fixtures don't
+  # need to touch the real $HOME (or be run as root with an odd HOME).
+  def stub_legacy_home(path)
+    original = Hive::Paths.method(:legacy_hive_home)
+    Hive::Paths.singleton_class.send(:define_method, :legacy_hive_home) { path }
+    # module_function creates private singleton wrappers; force public again.
+    yield
+  ensure
+    Hive::Paths.singleton_class.send(:alias_method, :legacy_hive_home, :legacy_hive_home)
+    Hive::Paths.define_singleton_method(:legacy_hive_home, original)
+  end
+
+  def capture_stderr
+    old = $stderr
+    $stderr = StringIO.new
+    yield
+    $stderr.string
+  ensure
+    $stderr = old
+  end
+end
diff --git a/test/unit/project_dirs_shim_test.rb b/test/unit/project_dirs_shim_test.rb
new file mode 100644
index 0000000..10ba4aa
--- /dev/null
+++ b/test/unit/project_dirs_shim_test.rb
@@ -0,0 +1,114 @@
+require "test_helper"
+require "fileutils"
+require "hive/git_ops"
+require "hive/task"
+
+# Unit tests for the .hive / .hive-state two-root back-compat shim
+# (plan figure-out-way-to-install-260513-4a0a U2):
+#   * Task PATH_RE parses both scaffold roots across stages 1–8
+#   * ProjectDirs.resolve precedence (canonical wins, both present)
+#   * GitOps resolves existing legacy trees read-only and creates
+#     `.hive/` on fresh scaffolds
+class ProjectDirsShimTest < Minitest::Test
+  include HiveTestHelper
+
+  def with_tmp_git_repo(&block)
+    super
+  end
+
+  def test_task_path_accepts_canonical_root_across_all_stages
+    stage = 0
+    Hive::Stages::DIRS.each do |dir|
+      stage += 1
+      path = "/tmp/proj/.hive/stages/#{dir}/my-task-260513-abcd"
+      task = Hive::Task.new(path)
+      assert_equal ".hive", task.state_dir_basename
+      assert_equal stage, task.stage_index
+      refute_predicate task, :legacy_state_dir?
+    end
+  end
+
+  def test_task_path_accepts_legacy_root_across_all_stages
+    Hive::Stages::DIRS.each do |dir|
+      path = "/tmp/proj/.hive-state/stages/#{dir}/my-task-260513-abcd"
+      task = Hive::Task.new(path)
+      assert_equal ".hive-state", task.state_dir_basename
+      assert_predicate task, :legacy_state_dir?
+    end
+  end
+
+  def test_task_invalid_stage_name_still_rejected_for_both_roots
+    [".hive", ".hive-state"].each do |root|
+      assert_raises(Hive::InvalidTaskPath) do
+        Hive::Task.new("/tmp/proj/#{root}/stages/1-notastage/my-task-260513-abcd")
+      end
+    end
+  end
+
+  def test_resolver_prefers_canonical_when_both_exist
+    with_tmp_dir do |dir|
+      FileUtils.mkdir_p(File.join(dir, ".hive"))
+      FileUtils.mkdir_p(File.join(dir, ".hive-state"))
+      assert_equal ".hive", Hive::ProjectDirs.resolve(dir), ".hive wins deterministically"
+    end
+  end
+
+  def test_resolver_picks_legacy_when_only_legacy_exists
+    with_tmp_dir do |dir|
+      FileUtils.mkdir_p(File.join(dir, ".hive-state"))
+      assert_equal ".hive-state", Hive::ProjectDirs.resolve(dir)
+    end
+  end
+
+  def test_resolver_defaults_to_canonical_when_neither_exists
+    with_tmp_dir do |dir|
+      assert_equal ".hive", Hive::ProjectDirs.resolve(dir)
+    end
+  end
+
+  def test_git_ops_resolves_existing_legacy_tree_readonly
+    with_tmp_git_repo do |dir|
+      FileUtils.mkdir_p(File.join(dir, ".hive-state", "stages"))
+      ops = Hive::GitOps.new(dir)
+      assert_equal File.join(dir, ".hive-state"), ops.hive_state_path
+      assert_predicate ops, :legacy_state_tree?
+    end
+  end
+
+  def test_git_ops_creates_canonical_hive_on_fresh_init
+    with_tmp_git_repo do |dir|
+      ops = Hive::GitOps.new(dir)
+      refute_predicate ops, :legacy_state_tree?
+      assert_equal :created, ops.hive_state_init
+      # Legacy dir created before init must NOT receive the new worktree.
+      FileUtils.mkdir_p(File.join(dir, ".hive")) unless File.exist?(File.join(dir, ".hive"))
+      Hive::Stages::DIRS.each do |stage|
+        assert File.directory?(File.join(dir, ".hive", "stages", stage))
+      end
+    end
+  end
+
+  def test_legacy_notice_memoizes_and_filters_canonical_basename
+    Hive.legacy_notice_announced = false
+    _, err = capture_io do
+      Hive.announce_legacy_project_dir!("/x/y/.hive-state")
+    end
+    assert_match(/legacy \.hive-state/, err)
+    assert_predicate Hive, :legacy_notice_announced
+
+    # Second call: suppressed by the once-per-process memo.
+    _, err2 = capture_io do
+      Hive.announce_legacy_project_dir!("/a/b/.hive-state")
+    end
+    assert_empty(err2)
+
+    # Canonical basename never trips the notice.
+    Hive.legacy_notice_announced = false
+    _, err3 = capture_io do
+      Hive.announce_legacy_project_dir!("/x/y/.hive")
+    end
+    assert_empty(err3)
+  ensure
+    Hive.legacy_notice_announced = true
+  end
+end
diff --git a/test/unit/reviewers/agent_test.rb b/test/unit/reviewers/agent_test.rb
index 5210776..ac445a6 100644
--- a/test/unit/reviewers/agent_test.rb
+++ b/test/unit/reviewers/agent_test.rb
@@ -24,7 +24,7 @@ class ReviewersAgentTest < Minitest::Test
   def make_ctx(dir)
     Hive::Reviewers::Context.new(
       worktree_path: dir,
-      task_folder: File.join(dir, ".hive-state", "stages", "6-review", "test"),
+      task_folder: File.join(dir, ".hive", "stages", "6-review", "test"),
       default_branch: "main",
       pass: 1
     )
diff --git a/test/unit/reviewers/synthetic_task_test.rb b/test/unit/reviewers/synthetic_task_test.rb
index 7e57271..3ae1774 100644
--- a/test/unit/reviewers/synthetic_task_test.rb
+++ b/test/unit/reviewers/synthetic_task_test.rb
@@ -12,7 +12,7 @@ class ReviewersSyntheticTaskTest < Minitest::Test
   def make_ctx(dir)
     Hive::Reviewers::Context.new(
       worktree_path: dir,
-      task_folder: File.join(dir, ".hive-state", "stages", "6-review", "synth-task"),
+      task_folder: File.join(dir, ".hive", "stages", "6-review", "synth-task"),
       default_branch: "main",
       pass: 1
     )
diff --git a/test/unit/reviewers_test.rb b/test/unit/reviewers_test.rb
index 9727dc4..d810708 100644
--- a/test/unit/reviewers_test.rb
+++ b/test/unit/reviewers_test.rb
@@ -7,7 +7,7 @@ class ReviewersTest < Minitest::Test
   def make_ctx(dir)
     Hive::Reviewers::Context.new(
       worktree_path: dir,
-      task_folder: File.join(dir, ".hive-state", "stages", "6-review", "test-task"),
+      task_folder: File.join(dir, ".hive", "stages", "6-review", "test-task"),
       default_branch: "main",
       pass: 1
     )
diff --git a/test/unit/schema_files_test.rb b/test/unit/schema_files_test.rb
index b5ce1b1..9081df6 100644
--- a/test/unit/schema_files_test.rb
+++ b/test/unit/schema_files_test.rb
@@ -224,7 +224,7 @@ class SchemaFilesTest < Minitest::Test
         {
           "name" => "alpha",
           "path" => "/tmp/alpha",
-          "hive_state_path" => "/tmp/alpha/.hive-state",
+          "hive_state_path" => "/tmp/alpha/.hive",
           "tasks" => [],
           "legacy_stage_dirs" => [
             { "stage_dir" => "5-review", "task_count" => 2 },
@@ -239,7 +239,7 @@ class SchemaFilesTest < Minitest::Test
           # legacy_migrate_command is explicitly null.
           "name" => "beta",
           "path" => "/tmp/beta",
-          "hive_state_path" => "/tmp/beta/.hive-state",
+          "hive_state_path" => "/tmp/beta/.hive",
           "tasks" => [],
           "legacy_stage_dirs" => [],
           "legacy_migrate_command" => nil
@@ -266,7 +266,7 @@ class SchemaFilesTest < Minitest::Test
         {
           "name" => "alpha",
           "path" => "/tmp/alpha",
-          "hive_state_path" => "/tmp/alpha/.hive-state",
+          "hive_state_path" => "/tmp/alpha/.hive",
           "tasks" => [],
           "legacy_stage_dirs" => [],
           "legacy_migrate_command" => false # not a string and not null
@@ -291,7 +291,7 @@ class SchemaFilesTest < Minitest::Test
         {
           "name" => "alpha",
           "path" => "/tmp/alpha",
-          "hive_state_path" => "/tmp/alpha/.hive-state",
+          "hive_state_path" => "/tmp/alpha/.hive",
           "tasks" => [],
           "legacy_stage_dirs" => [ { "stage_dir" => "6-pr" } ] # missing task_count
         }
@@ -902,7 +902,7 @@ class SchemaFilesTest < Minitest::Test
     # this will fail before CI.
     producer = Hive::Commands::Forget.new("anything", json: true).send(
       :success_payload,
-      { "name" => "demo", "path" => "/tmp/hive-demo", "hive_state_path" => "/tmp/hive-demo/.hive-state" }
+      { "name" => "demo", "path" => "/tmp/hive-demo", "hive_state_path" => "/tmp/hive-demo/.hive" }
     )
     assert_equal schema_required, producer.keys.sort,
                  "Forget#success_payload must emit exactly the schema's required keys"
@@ -1154,7 +1154,7 @@ class SchemaFilesTest < Minitest::Test
       "subcommand" => "enable",
       "results" => [
         { "name" => "p", "path" => "/tmp/p", "previous" => false,
-          "current" => true, "config_yml" => "/tmp/p/.hive-state/config.yml" }
+          "current" => true, "config_yml" => "/tmp/p/.hive/config.yml" }
       ],
       "next_action" => {
         "kind" => "reload",
@@ -1179,7 +1179,7 @@ class SchemaFilesTest < Minitest::Test
       "subcommand" => "enable",
       "results" => [
         { "name" => "p", "path" => "/tmp/p", "previous" => nil,
-          "current" => true, "config_yml" => "/tmp/p/.hive-state/config.yml" }
+          "current" => true, "config_yml" => "/tmp/p/.hive/config.yml" }
       ]
     }
     errors = schemer.validate(legacy_payload).map { |e| e["error"] }
diff --git a/test/unit/service_test.rb b/test/unit/service_test.rb
new file mode 100644
index 0000000..54ba52b
--- /dev/null
+++ b/test/unit/service_test.rb
@@ -0,0 +1,187 @@
+require "test_helper"
+require "hive/service"
+require "hive/commands/init"
+require "stringio"
+
+# U5 (plan figure-out-way-to-install-260513-4a0a): per-user daemon
+# service registration — manifest rendering, prompt defaults, and the
+# start/register/skip contract. Platform manager invocations are stubbed;
+# nothing here touches a real launchd/systemd.
+class HiveServiceTest < Minitest::Test
+  include HiveTestHelper
+
+  ORIGINAL_PLATFORM = Hive::Service.method(:platform)
+  ORIGINAL_SUPPORTED = Hive::Service.method(:supported?)
+
+  def setup
+    # Force the linux branch + supportedness deterministically.
+    Hive::Service.define_singleton_method(:platform) { :linux }
+    Hive::Service.define_singleton_method(:supported?) { true }
+  end
+
+  def teardown
+    Hive::Service.define_singleton_method(:platform, ORIGINAL_PLATFORM)
+    Hive::Service.define_singleton_method(:supported?, ORIGINAL_SUPPORTED)
+    Hive::Service.instance_variable_set(:@bin_path, nil)
+  end
+
+  def with_service_sandbox(home)
+    # Point Paths (manifests) and the manager binary at a hermetic sandbox.
+    saved_home = ENV["HIVE_HOME"]
+    old_bin = ENV["HIVE_SERVICE_BIN"]
+    dir = Dir.mktmpdir("hive-service-home")
+    ENV["HIVE_HOME"] = dir
+    ENV["HIVE_SERVICE_BIN"] = File.join(home, "bin", "hive")
+    yield dir
+  ensure
+    FileUtils.rm_rf(dir) if dir
+    if saved_home.nil?
+      ENV.delete("HIVE_HOME")
+    else
+      ENV["HIVE_HOME"] = saved_home
+    end
+    if old_bin.nil?
+      ENV.delete("HIVE_SERVICE_BIN")
+    else
+      ENV["HIVE_SERVICE_BIN"] = old_bin
+    end
+  end
+
+  def test_renders_linux_unit_with_restart_on_failure_and_state_paths
+    text = Hive::Service.render("hive.service.erb", Hive::Service.template_bindings)
+    assert_includes text, "Restart=on-failure"
+    bin_path = Hive::Service.template_bindings[:bin_path]
+    assert_match(/ExecStart=#{Regexp.escape(bin_path)} daemon start/, text)
+    assert_includes text, "WantedBy=default.target"
+  end
+
+  def test_renders_macos_plist_with_label_keepalive_and_daemon_args
+    text = Hive::Service.render("io.github.ivankuznetsov.hive.plist.erb",
+                                Hive::Service.template_bindings)
+    assert_includes text, "<string>#{Hive::Service::LABEL}</string>"
+    assert_includes text, "<key>KeepAlive</key>"
+    assert_includes text, "<key>RunAtLoad</key>"
+    # ProgramArguments carries `<bin> daemon start`
+    bin_path = Hive::Service.template_bindings[:bin_path]
+    assert_match(/<string>#{Regexp.escape(bin_path)}<\/string>\s*<string>daemon<\/string>\s*<string>start<\/string>/m,
+                 text)
+    assert_equal 1, text.scan("<plist").size
+  end
+
+  def test_register_writes_manifest_and_start_now_enables
+    with_tmp_dir do |home|
+      with_service_sandbox(home) do
+        captured = []
+        stub_managers(captured) do
+          result = Hive::Service.register!(Hive::Service::START_NOW)
+          assert result[:started_now]
+          expected_manifest = File.join(Hive::Paths.state_dir, "systemd", "user", "hive.service")
+          assert_equal expected_manifest, result[:manifest]
+          assert File.exist?(expected_manifest)
+          assert_includes File.read(expected_manifest), "Restart=on-failure"
+        end
+        enabled_call = captured.find { |args| args.join(" ").include?("enable --now") }
+        refute_nil enabled_call, "start_now must enable --now the user unit"
+        reload_call = captured.find { |args| args.join(" ").include?("daemon-reload") }
+        refute_nil reload_call
+      end
+    end
+  end
+
+  def test_register_only_never_starts_the_unit
+    with_tmp_dir do |home|
+      with_service_sandbox(home) do
+        captured = []
+        stub_managers(captured) do
+          result = Hive::Service.register!(Hive::Service::REGISTER_ONLY)
+          refute result[:started_now]
+          assert File.exist?(result[:manifest])
+        end
+        started = captured.any? { |args| args.include?("--now") }
+        refute started, "register-only must not enable/start anything"
+      end
+    end
+  end
+
+  def test_prompt_non_tty_defaults_to_register_only
+    out = StringIO.new
+    prompt = Hive::ServiceRegisterPrompt.new(input: StringIO.new, output: out)
+    assert_equal Hive::Service::REGISTER_ONLY, prompt.ask
+    assert_match(/registering only/, out.string)
+  end
+
+  def test_prompt_tty_answers_map_to_choices
+    [ [ "start\n", Hive::Service::START_NOW ],
+      [ "\n", Hive::Service::START_NOW ],
+      [ "register\n", Hive::Service::REGISTER_ONLY ],
+      [ "skip\n", Hive::Service::SKIP ],
+      [ "bogus\nstart\n", Hive::Service::START_NOW ] ].each do |input_text, expected|
+      out = StringIO.new
+      answer = Hive::ServiceRegisterPrompt.new(input: tty_io(input_text), output: out).ask
+      assert_equal expected, answer, "input #{input_text.inspect}"
+    end
+  end
+
+  def test_prompt_eof_mid_question_returns_skip_never_autostart
+    out = StringIO.new
+    # An empty, EOF-at-start stream: gets returns nil immediately.
+    input = StringIO.new("")
+    input.define_singleton_method(:tty?) { true }
+    answer = Hive::ServiceRegisterPrompt.new(input: input, output: out).ask
+    assert_equal Hive::Service::SKIP, answer, "EOF must degrade to skip"
+  end
+
+  def test_init_register_service_guard_honors_hive_no_service
+    prev = ENV["HIVE_NO_SERVICE"]
+    ENV["HIVE_NO_SERVICE"] = "1"
+    init = Hive::Commands::Init.allocate
+    called = false
+    begin
+      result = nil
+      _out, _err = capture_io do
+        result = init.send(:register_service!)
+      end
+      assert_nil result
+      refute called
+    ensure
+      if prev.nil?
+        ENV["HIVE_NO_SERVICE"] = nil
+      else
+        ENV["HIVE_NO_SERVICE"] = prev
+      end
+    end
+  end
+
+  private
+
+  def tty_io(text)
+    io = StringIO.new(text)
+    io.define_singleton_method(:tty?) { true }
+    io
+  end
+
+  # Stubs both the run! helper and Open3.capture3 so register!/start!/
+  # unload! never spawn a real manager binary. Collector receives each
+  # command argv array.
+  def stub_managers(collector)
+    original_run = Hive::Service.method(:run!)
+    Hive::Service.define_singleton_method(:run!) do |*cmd|
+      collector << cmd.map(&:to_s)
+      ""
+    end
+
+    original_capture3 = Open3.method(:capture3)
+    ok_status = begin
+      system("true")
+      $CHILD_STATUS.clone
+    end
+    Open3.define_singleton_method(:capture3) do |*cmd, **opts|
+      collector << cmd.map(&:to_s)
+      [ "", "", ok_status ]
+    end
+    yield
+  ensure
+    Hive::Service.define_singleton_method(:run!, original_run)
+    Open3.define_singleton_method(:capture3, original_capture3)
+  end
+end
diff --git a/test/unit/spawn_agent_test.rb b/test/unit/spawn_agent_test.rb
index 1698278..51045dc 100644
--- a/test/unit/spawn_agent_test.rb
+++ b/test/unit/spawn_agent_test.rb
@@ -33,7 +33,7 @@ class SpawnAgentTest < Minitest::Test
   end
 
   def make_task(dir, stage = "2-brainstorm", slug = "spawn-test-260425-aaaa")
-    folder = File.join(dir, ".hive-state", "stages", stage, slug)
+    folder = File.join(dir, ".hive", "stages", stage, slug)
     FileUtils.mkdir_p(folder)
     Hive::Task.new(folder)
   end
diff --git a/test/unit/stages/brainstorm_tmux_sentinel_test.rb b/test/unit/stages/brainstorm_tmux_sentinel_test.rb
index 53362e7..5e748f0 100644
--- a/test/unit/stages/brainstorm_tmux_sentinel_test.rb
+++ b/test/unit/stages/brainstorm_tmux_sentinel_test.rb
@@ -65,7 +65,7 @@ class BrainstormTmuxSentinelTest < Minitest::Test
 
   def with_tmp_task_folder
     with_tmp_dir do |root|
-      folder = File.join(root, ".hive-state", "stages", "2-brainstorm", "slug-260514-aaaa")
+      folder = File.join(root, ".hive", "stages", "2-brainstorm", "slug-260514-aaaa")
       FileUtils.mkdir_p(folder)
       yield Hive::Task.new(folder)
     end
diff --git a/test/unit/stages/done_test.rb b/test/unit/stages/done_test.rb
index d308c2e..06e2607 100644
--- a/test/unit/stages/done_test.rb
+++ b/test/unit/stages/done_test.rb
@@ -15,7 +15,7 @@ class StagesDoneTest < Minitest::Test
   def test_run_returns_cleanup_instructions_with_pointer_and_writes_nothing_to_stdout
     with_tmp_dir do |dir|
       slug = "feat-x-260424-aaaa"
-      folder = File.join(dir, ".hive-state", "stages", "8-done", slug)
+      folder = File.join(dir, ".hive", "stages", "8-done", slug)
       FileUtils.mkdir_p(folder)
       File.write(File.join(folder, "worktree.yml"),
                  { "path" => "/tmp/wt-feat-x", "branch" => slug }.to_yaml)
@@ -43,7 +43,7 @@ class StagesDoneTest < Minitest::Test
   def test_run_returns_archived_message_without_pointer
     with_tmp_dir do |dir|
       slug = "feat-y-260424-bbbb"
-      folder = File.join(dir, ".hive-state", "stages", "8-done", slug)
+      folder = File.join(dir, ".hive", "stages", "8-done", slug)
       FileUtils.mkdir_p(folder)
       task = Hive::Task.new(folder)
       cfg = Hive::Config.load(dir)
@@ -61,7 +61,7 @@ class StagesDoneTest < Minitest::Test
   def test_run_sets_complete_marker_on_state_file
     with_tmp_dir do |dir|
       slug = "feat-z-260424-cccc"
-      folder = File.join(dir, ".hive-state", "stages", "8-done", slug)
+      folder = File.join(dir, ".hive", "stages", "8-done", slug)
       FileUtils.mkdir_p(folder)
       task = Hive::Task.new(folder)
       cfg = Hive::Config.load(dir)
diff --git a/test/unit/stages/review/browser_test_test.rb b/test/unit/stages/review/browser_test_test.rb
index 3457d5f..aa5b89d 100644
--- a/test/unit/stages/review/browser_test_test.rb
+++ b/test/unit/stages/review/browser_test_test.rb
@@ -28,7 +28,7 @@ class BrowserTestTest < Minitest::Test
 
   def with_browser_dir(pass: 1)
     with_tmp_dir do |dir|
-      task_folder = File.join(dir, ".hive-state", "stages", "6-review", "browser-test-task")
+      task_folder = File.join(dir, ".hive", "stages", "6-review", "browser-test-task")
       FileUtils.mkdir_p(File.join(task_folder, "reviews"))
       FileUtils.mkdir_p(File.join(task_folder, "logs"))
       ctx = Hive::Reviewers::Context.new(
